All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends
faiss::ConcatenatedInvertedLists Struct Reference

`#include <InvertedLists.h>`

Inheritance diagram for faiss::ConcatenatedInvertedLists:

## Public Member Functions

| ConcatenatedInvertedLists (int nil, const InvertedLists **ils)
| build InvertedLists by concatenating nil of them
size_t | list_size (size_t list_no) const override
| get the size of a list
const uint8_t * | get_codes (size_t list_no) const override
const idx_t * | get_ids (size_t list_no) const override
void | release_codes (const uint8_t *codes) const override
| release codes returned by get_codes (default implementation is nop
void | release_ids (const idx_t *ids) const override
| release ids returned by get_ids
idx_t | get_single_id (size_t list_no, size_t offset) const override
const uint8_t * | get_single_code (size_t list_no, size_t offset) const override
size_t | add_entries (size_t list_no, size_t n_entry, const idx_t *ids, const uint8_t *code) override
void | update_entries (size_t list_no, size_t offset, size_t n_entry, const idx_t *ids, const uint8_t *code) override
void | resize (size_t list_no, size_t new_size) override
Public Member Functions inherited from faiss::InvertedLists
| InvertedLists (size_t nlist, size_t code_size)
virtual void | prefetch_lists (const long *list_nos, int nlist) const
virtual size_t | add_entry (size_t list_no, idx_t theid, const uint8_t *code)
| add one entry to an inverted list
virtual void | update_entry (size_t list_no, size_t offset, idx_t id, const uint8_t *code)
virtual void | reset ()
void | merge_from (InvertedLists *oivf, size_t add_id)
| move all entries from oivf (empty on output)

## Public Attributes

std::vector< const InvertedLists * > | ils
Public Attributes inherited from faiss::InvertedLists
size_t | nlist
| number of possible key values
size_t | code_size
| code size per vector in bytes

## Additional Inherited Members

Public Types inherited from faiss::InvertedLists
typedef Index::idx_t | idx_t

## Detailed Description

inverted lists built as the concatenation of a set of invlists (read-only)

Definition at line 193 of file InvertedLists.h.

## Member Function Documentation

const uint8_t * faiss::ConcatenatedInvertedLists::get_codes | ( | size_t | list_no | ) | const

override virtual

get the codes for an inverted list must be released by release_codes

Returns
  codes size list_size * code_size

Implements faiss::InvertedLists.

Definition at line 192 of file InvertedLists.cpp.

const Index::idx_t * faiss::ConcatenatedInvertedLists::get_ids | ( | size_t | list_no | ) | const

override virtual

get the ids for an inverted list must be released by release_ids

Returns
  ids size list_size

Implements faiss::InvertedLists.

Definition at line 229 of file InvertedLists.cpp.

const uint8_t * faiss::ConcatenatedInvertedLists::get_single_code | ( | size_t | list_no,
|  | size_t | offset
| ) |  | const

override virtual

Returns
  a single code in an inverted list (should be deallocated with release_codes)

Reimplemented from faiss::InvertedLists.

Definition at line 207 of file InvertedLists.cpp.

Index::idx_t faiss::ConcatenatedInvertedLists::get_single_id | ( | size_t | list_no,
|  | size_t | offset
| ) |  | const

override virtual

Returns
  a single id in an inverted list

Reimplemented from faiss::InvertedLists.

Definition at line 244 of file InvertedLists.cpp.

The documentation for this struct was generated from the following files:

- /tmp/faiss/InvertedLists.h
- /tmp/faiss/InvertedLists.cpp